"use strict";

var _manifest = require("./manifest");

var _assert = require("assert");

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mod_573300145710716007 = function (a, b) {
    return (a % b + b) % b;
};var dotDotCalc_573300145710716007 = function (dotDot, a, b, c) {
    return dotDot(a)[b](a, ...c);
};var asyncToGenerator_573300145710716007 = function (fn) {
    var gen = fn.call(this);
    return new Promise(function (resolve, reject) {
        function step(key, arg) {
            try {
                var info = gen[key](arg);
                var value = info.value;
            } catch (error) {
                reject(error);
                return;
            }
            if (info.done) {
                resolve(value);
            } else {
                Promise.resolve(value).then(function (value) {
                    step("next", value);
                }, function (err) {
                    step("throw", err);
                });
            }
        }
        step("next");
    });
};var sleep;sleep = function (ms) {
    return (() => {
        Atomics.wait(new Int32Array(new SharedArrayBuffer(4)), 0, 0, ms);return undefined;
    })();
};describe("compatibility", function () {
    return (() => {
        it("setImmediate", function (done) {
            return (() => {
                var value;value = 1;(0, _manifest.setImmediate)(function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        _assert2.default.strictEqual(value, 2);return done();
                    })();
                });value = 2;
            })();
        });return it("clearImmediate", function (done) {
            return (() => {
                var value, timer;value = 1;timer = (0, _manifest.setImmediate)(function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        value = 2;
                    })();
                });(0, _manifest.clearImmediate)(timer);return setTimeout(function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        _assert2.default.strictEqual(value, 1);return done();
                    })();
                }, 100);
            })();
        });
    })();
});describe("loop", function () {
    return (() => {
        it("array: number, diamond function", function () {
            return (() => {
                var r, ret;r = [];ret = (0, _manifest.loop)(5, function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        return r.push(1);
                    })();
                });_assert2.default.deepStrictEqual(r, [1, 1, 1, 1, 1]);return _assert2.default.strictEqual(ret, undefined);
            })();
        });it("array: number, arrow function", function () {
            return (() => {
                var r;r = [];(0, _manifest.loop)(5, function (i) {
                    return (() => {
                        return r.push(i);
                    })();
                });return _assert2.default.deepStrictEqual(r, [0, 1, 2, 3, 4]);
            })();
        });it("object: by 2 with break", function () {
            return (() => {
                var r;r = [];(0, _manifest.loop)({ [""]: 1, by: 2, for: function (i) {
                        return (() => {
                            r.push(i);return i > 9 ? (() => {
                                return _manifest.break;
                            })() : undefined;
                        })();
                    } });return _assert2.default.deepStrictEqual(r, [1, 3, 5, 7, 9, 11]);
            })();
        });it("array: number, arrow function with break", function () {
            return (() => {
                var r;r = [];(0, _manifest.loop)(10, function (i) {
                    return (() => {
                        r.push(i);return i > 5 ? (() => {
                            return _manifest.break;
                        })() : undefined;
                    })();
                });return _assert2.default.deepStrictEqual(r, [0, 1, 2, 3, 4, 5, 6]);
            })();
        });it("object: canonical", function () {
            return (() => {
                var r;r = [];(0, _manifest.loop)({ from: 1, to: 5, for: function (i) {
                        return (() => {
                            return r.push(i);
                        })();
                    } });return _assert2.default.deepStrictEqual(r, [1, 2, 3, 4, 5]);
            })();
        });it("object: normal", function () {
            return (() => {
                var r;r = [];(0, _manifest.loop)({ [""]: 1, to: 5, for: function (i) {
                        return (() => {
                            return r.push(i);
                        })();
                    } });return _assert2.default.deepStrictEqual(r, [1, 2, 3, 4, 5]);
            })();
        });it("object: by -1", function () {
            return (() => {
                var r;r = [];(0, _manifest.loop)({ [""]: 5, to: 1, by: -1, for: function (i) {
                        return (() => {
                            return r.push(i);
                        })();
                    } });return _assert2.default.deepStrictEqual(r, [5, 4, 3, 2, 1]);
            })();
        });return it("function: with break", function () {
            return (() => {
                var r;r = [];(0, _manifest.loop)(function (i) {
                    return (() => {
                        r.push(i);return i > 3 ? (() => {
                            return _manifest.break;
                        })() : undefined;
                    })();
                });return _assert2.default.deepStrictEqual(r, [0, 1, 2, 3, 4]);
            })();
        });
    })();
});describe("repeat", function () {
    return (() => {
        return it("repeat", function () {
            return (() => {
                _assert2.default.deepStrictEqual((0, _manifest.repeat)(5, function (i) {
                    return (() => {
                        return i + 2;
                    })();
                }), [2, 3, 4, 5, 6]);_assert2.default.deepStrictEqual((0, _manifest.repeat)(5), [0, 1, 2, 3, 4]);_assert2.default.deepStrictEqual((0, _manifest.repeat)({ [""]: 1, to: 10, by: 2 }), [1, 3, 5, 7, 9]);return _assert2.default.deepStrictEqual((0, _manifest.repeat)({ [""]: 1, by: 2, for: function (i) {
                        return (() => {
                            return i > 9 ? (() => {
                                return _manifest.break;
                            })() : (() => {
                                return i;
                            })();
                        })();
                    } }), [1, 3, 5, 7, 9]);
            })();
        });
    })();
});describe("enum", function () {
    return (() => {
        return it("enum", function () {
            return (() => {
                _assert2.default.deepStrictEqual((0, _manifest.enum)({ a: true }), { a: 0 });return _assert2.default.deepStrictEqual((0, _manifest.enum)({ a: true, b: true }), { a: 0, b: 1 });
            })();
        });
    })();
});describe("compose", function () {
    return (() => {
        it("multiple arguments", function () {
            return (() => {
                var a;a = (0, _manifest.compose)(Math.min, Math.abs);return _assert2.default.strictEqual(a(-2, -3), 3);
            })();
        });return it("array argument", function () {
            return (() => {
                var a;a = (0, _manifest.compose)([Math.min, Math.abs]);return _assert2.default.strictEqual(a(-2, -3), 3);
            })();
        });
    })();
});describe("spread", function () {
    return (() => {
        return it("spread", function () {
            return (() => {
                return _assert2.default.deepStrictEqual((0, _manifest.spread)(0, 3), [0, 0, 0]);
            })();
        });
    })();
});describe("eventField", function () {
    return (() => {
        it("basic", function () {
            return (() => {
                var r, Obj, obj;r = null;Obj = (() => {
                    var class_573300145710716007 = class {
                        constructor() {
                            (() => {
                                return (() => {
                                    this.onClick = (0, _manifest.eventField)();
                                })();
                            })();
                        }makeClick() {
                            return (() => {
                                return (() => {
                                    return this.onClick.fire();
                                })();
                            })();
                        }
                    };return class_573300145710716007;
                })();obj = new Obj();obj.onClick(function () {
                    return (() => {
                        r = true;
                    })();
                });obj.makeClick();return _assert2.default.strictEqual(r, true);
            })();
        });it("advanced", function () {
            return (() => {
                var r1, r2, Obj, obj;r1 = null;r2 = null;Obj = (() => {
                    var class_573300145710716007 = class {
                        constructor() {
                            (() => {
                                return (() => {
                                    this.onClick = (0, _manifest.eventField)();
                                })();
                            })();
                        }makeClick() {
                            return (() => {
                                return (() => {
                                    return this.onClick.fire({ a: 5 });
                                })();
                            })();
                        }
                    };return class_573300145710716007;
                })();obj = new Obj();obj.onClick(function (e, holder) {
                    return (() => {
                        r1 = e;r2 = holder;
                    })();
                });obj.makeClick();_assert2.default.strictEqual(r1.a, 5);return _assert2.default.strictEqual(r2, obj);
            })();
        });it("more advanced", function () {
            return (() => {
                var listener1Holder, listener2Holder, callOrder, Obj, obj, listener1, listener2;listener1Holder = undefined;listener2Holder = undefined;callOrder = [];Obj = (() => {
                    var class_573300145710716007 = class {
                        constructor() {
                            (() => {
                                return (() => {
                                    this.onClick = (0, _manifest.eventField)();
                                })();
                            })();
                        }makeClick() {
                            return (() => {
                                return (() => {
                                    return this.onClick.fire();
                                })();
                            })();
                        }
                    };return class_573300145710716007;
                })();obj = new Obj();obj.onClick.bind(listener1 = function (e, holder) {
                    return (() => {
                        listener1Holder = holder;return callOrder.push(1);
                    })();
                });obj.makeClick();_assert2.default.strictEqual(listener1Holder, null);obj.onClick(listener2 = function (e, holder) {
                    return (() => {
                        listener2Holder = holder;return callOrder.push(2);
                    })();
                });obj.makeClick();_assert2.default.strictEqual(listener1Holder, obj);_assert2.default.strictEqual(listener2Holder, obj);_assert2.default.deepStrictEqual(callOrder, [1, 1, 2]);_assert2.default.strictEqual(obj.onClick.getListeners().length, 2);_assert2.default.strictEqual(obj.onClick.getListeners()[0], listener1);return _assert2.default.strictEqual(obj.onClick.getListeners()[1], listener2);
            })();
        });it("unbind", function () {
            return (() => {
                var r, Obj, obj, listener1, listener2, listener3;r = [];Obj = (() => {
                    var class_573300145710716007 = class {
                        constructor() {
                            (() => {
                                return (() => {
                                    this.onClick = (0, _manifest.eventField)();
                                })();
                            })();
                        }makeClick() {
                            return (() => {
                                return (() => {
                                    return this.onClick.fire();
                                })();
                            })();
                        }
                    };return class_573300145710716007;
                })();obj = new Obj();obj.onClick(listener1 = function () {
                    return (() => {
                        return r.push(true);
                    })();
                }).onClick(listener2 = function () {
                    return (() => {
                        return r.push(false);
                    })();
                }).onClick(listener3 = function () {
                    return (() => {
                        return r.push(10);
                    })();
                });obj.makeClick();_assert2.default.deepStrictEqual(r, [true, false, 10]);r = [];obj.onClick.unbind(listener2);obj.makeClick();_assert2.default.deepStrictEqual(r, [true, 10]);_assert2.default.strictEqual(obj.onClick.getListeners().length, 2);_assert2.default.strictEqual(obj.onClick.getListeners()[0], listener1);_assert2.default.strictEqual(obj.onClick.getListeners()[1], listener3);r = [];obj.onClick.unbindAll();obj.makeClick();_assert2.default.deepStrictEqual(r, []);return _assert2.default.strictEqual(obj.onClick.getListeners().length, 0);
            })();
        });return it("async", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var oldTime, r, Obj, obj, actualMs, var_573300145710716007_2;oldTime = new Date();r = [];Obj = yield asyncToGenerator_573300145710716007.call(this, function* () {
                    var class_573300145710716007 = class {
                        constructor() {
                            (() => {
                                return (() => {
                                    this.onClick = (0, _manifest.eventField)();
                                })();
                            })();
                        }makeClick() {
                            return (() => {
                                return asyncToGenerator_573300145710716007.call(this, function* () {
                                    yield this.onClick.asyncFire();return r.push(3);
                                });
                            })();
                        }
                    };return class_573300145710716007;
                });obj = new Obj();obj.onClick(function () {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);return r.push(1);
                    });
                }).onClick(function () {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);return r.push(2);
                    });
                });yield obj.makeClick();actualMs = new Date() - oldTime;_assert2.default.deepStrictEqual(r, [1, 2, 3]);return (0, _assert2.default)(100 <= (var_573300145710716007_2 = actualMs) && var_573300145710716007_2 <= 130);
            });
        });
    })();
});describe("string", function () {
    return (() => {
        it("bound", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "", "bound", []), -1);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "aaa", "bound", []), 2);
            })();
        });it("format", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "a {0} b {1}", "format", ["qq", "r"]), "a qq b r");
            })();
        });it("insert", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "aaa", "insert", [1, "b"]), "abaa");
            })();
        });it("remove", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "abcde", "remove", [1, 2]), "ade");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "abcde", "remove", [1]), "acde");
            })();
        });it("matches", function () {
            return (() => {
                var matches;matches = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "aaa bbb", "matches", [new RegExp("a")]);(0, _assert2.default)(matches instanceof Array);_assert2.default.strictEqual(matches.length, 3);(0, _assert2.default)(matches[0] instanceof Array);_assert2.default.strictEqual(matches[0].length, 1);_assert2.default.strictEqual(matches[0][0], "a");_assert2.default.strictEqual(matches[0].index, 0);(0, _assert2.default)(matches[1] instanceof Array);_assert2.default.strictEqual(matches[1].length, 1);_assert2.default.strictEqual(matches[1][0], "a");_assert2.default.strictEqual(matches[1].index, 1);(0, _assert2.default)(matches[2] instanceof Array);_assert2.default.strictEqual(matches[2].length, 1);_assert2.default.strictEqual(matches[2][0], "a");return _assert2.default.strictEqual(matches[2].index, 2);
            })();
        });it("capitalize", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "abc", "capitalize", []), "Abc");
            })();
        });it("split", function () {
            return (() => {
                _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "a:b,c:d", "split", [",", ":"]), [["a", "b"], ["c", "d"]]);return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "a:b,c:d", "split", [[",", ":"]]), [["a", "b"], ["c", "d"]]);
            })();
        });it("stripTrailingNewline", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "a\nb\n", "stripTrailingNewline", []), "a\nb");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "a\nb", "stripTrailingNewline", []), "a\nb");
            })();
        });it("ensureTrailingNewline", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "a\nb\n", "ensureTrailingNewline", []), "a\nb\n");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "a\nb", "ensureTrailingNewline", []), "a\nb\n");
            })();
        });return it("toBytes", function () {
            return (() => {
                return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, "A我们BC", "toBytes", []), new Uint8Array([0x41, 0xe6, 0x88, 0x91, 0xe4, 0xbb, 0xac, 0x42, 0x43]));
            })();
        });
    })();
});describe("math", function () {
    return (() => {
        it("approxEquals", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [1, 1.000000001]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [1, 0.999999999]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [1, 1.001]), false);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [1, 0.999]), false);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [0, 0.000000001]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [0, 0.001]), false);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [0, 0]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [-0, 0]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [-0, -0]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [-0.000000001, 0.000000001]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [0.000000001, -0.000000001]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [-1, -1.000000001]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [-1, -1.001]), false);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [0, -0.001]), false);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [0, -0.000000001]), true);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxEquals", [-0.000000001, 0]), true);
            })();
        });it("approxGreaterThan", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxGreaterThan", [1, 1.000000001]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxGreaterThan", [1, 0.999999999]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxGreaterThan", [1, 1.001]), false);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxGreaterThan", [1, 0.999]), true);
            })();
        });it("approxLessThan", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxLessThan", [1, 1.000000001]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxLessThan", [1, 0.999999999]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxLessThan", [1, 1.001]), true);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "approxLessThan", [1, 0.999]), false);
            })();
        });it("radiansToDegrees", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "radiansToDegrees", [Math.PI]), 180);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "radiansToDegrees", [Math.PI * 2]), 360);
            })();
        });it("degreesToRadians", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "degreesToRadians", [180]), Math.PI);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "degreesToRadians", [360]), Math.PI * 2);
            })();
        });it("principalRadians", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "principalRadians", [Math.PI * 0.5]), Math.PI * 0.5);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "principalRadians", [Math.PI]), Math.PI);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "principalRadians", [Math.PI * 2]), 0);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "principalRadians", [-Math.PI]), Math.PI);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "principalRadians", [Math.PI * 1.5]), -Math.PI * 0.5);
            })();
        });it("principalDegrees", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "principalDegrees", [90]), 90);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "principalDegrees", [180]), 180);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "principalDegrees", [360]), 0);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "principalDegrees", [-180]), 180);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "principalDegrees", [270]), -90);
            })();
        });it("roundDecimal", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "roundDecimal", [1.678]), 2);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "roundDecimal", [1.678, 2]), 1.68);
            })();
        });it("randomNumber", function () {
            return (() => {
                var r;r = (0, _manifest.repeat)(60, function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        return dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "randomNumber", [1, 3]);
                    })();
                });(0, _assert2.default)(r.every(function (m) {
                    return (() => {
                        var var_573300145710716007_3;return 1 <= (var_573300145710716007_3 = m) && var_573300145710716007_3 < 3;
                    })();
                }));(0, _assert2.default)(r.some(function (m) {
                    return (() => {
                        var var_573300145710716007_4;return 1 <= (var_573300145710716007_4 = m) && var_573300145710716007_4 < 2;
                    })();
                }));(0, _assert2.default)(r.some(function (m) {
                    return (() => {
                        var var_573300145710716007_5;return 2 <= (var_573300145710716007_5 = m) && var_573300145710716007_5 < 3;
                    })();
                }));return (0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r, "distinct", []).length > 1);
            })();
        });return it("randomInt", function () {
            return (() => {
                var r;r = (0, _manifest.repeat)(60, function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        return dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Math, "randomInt", [1, 3]);
                    })();
                });(0, _assert2.default)(r.every(function (m) {
                    return (() => {
                        return m === 1 || m === 2;
                    })();
                }));(0, _assert2.default)(r.some(function (m) {
                    return (() => {
                        return m === 1;
                    })();
                }));(0, _assert2.default)(r.some(function (m) {
                    return (() => {
                        return m === 2;
                    })();
                }));return (0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r, "distinct", []).length > 1);
            })();
        });
    })();
});describe("array", function () {
    return (() => {
        it("clone", function () {
            return (() => {
                var a, b;a = [1, 2, 3];b = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, a, "clone", []);_assert2.default.notStrictEqual(b, a);return _assert2.default.deepStrictEqual(b, a);
            })();
        });it("bound", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [], "bound", []), -1);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 1, 1], "bound", []), 2);
            })();
        });it("isEmpty", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [], "isEmpty", []), true);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1], "isEmpty", []), false);
            })();
        });it("portion", function () {
            return (() => {
                _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5, 6], "portion", [2, 3]), [3, 4, 5]);_assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5, 6], "portion", [2, undefined, 3]), [3, 4]);_assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5, 6], "portion", [2]), [3, 4, 5, 6]);return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5, 6], "portion", [2, undefined, 0.999]), [3, 4, 5, 6]);
            })();
        });it("at", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "at", [1]), 2);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "at", [0.5]), 3);
            })();
        });it("atOrNull", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "atOrNull", [1]), 2);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "atOrNull", [10]), null);
            })();
        });it("atOrVoid", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "atOrVoid", [1]), 2);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "atOrVoid", [10]), undefined);
            })();
        });it("includes", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3], "includes", [3]), true);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3], "includes", [4]), false);
            })();
        });it("first", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "first", []), 1);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "first", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 0;
                    })();
                }]), 2);
            })();
        });it("firstOrNull", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "firstOrNull", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 0;
                    })();
                }]), 2);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "firstOrNull", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 2;
                    })();
                }]), null);
            })();
        });it("firstOrVoid", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "firstOrVoid", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 0;
                    })();
                }]), 2);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "firstOrVoid", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 2;
                    })();
                }]), undefined);
            })();
        });it("last", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "last", []), 5);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "last", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 0;
                    })();
                }]), 4);
            })();
        });it("lastOrNull", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "lastOrNull", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 0;
                    })();
                }]), 4);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "lastOrNull", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 2;
                    })();
                }]), null);
            })();
        });it("lastOrVoid", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "lastOrVoid", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 0;
                    })();
                }]), 4);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "lastOrVoid", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 2;
                    })();
                }]), undefined);
            })();
        });it("single", function () {
            return (() => {
                _assert2.default.throws(function () {
                    return (() => {
                        return dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "single", []);
                    })();
                });_assert2.default.throws(function () {
                    return (() => {
                        return dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "single", [function (m) {
                            return (() => {
                                return m === 10;
                            })();
                        }]);
                    })();
                });return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "single", [function (m) {
                    return (() => {
                        return m === 3;
                    })();
                }]), 3);
            })();
        });it("singleOrNull", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "singleOrNull", [function (m) {
                    return (() => {
                        return m === 3;
                    })();
                }]), 3);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "singleOrNull", [function (m) {
                    return (() => {
                        return m === 10;
                    })();
                }]), null);
            })();
        });it("singleOrVoid", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "singleOrVoid", [function (m) {
                    return (() => {
                        return m === 3;
                    })();
                }]), 3);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "singleOrVoid", [function (m) {
                    return (() => {
                        return m === 10;
                    })();
                }]), undefined);
            })();
        });it("withMax", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "withMax", [function (m) {
                    return (() => {
                        return -m;
                    })();
                }]), 1);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "withMax", []), 5);
            })();
        });it("withMin", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "withMin", [function (m) {
                    return (() => {
                        return -m;
                    })();
                }]), 5);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "withMin", []), 1);
            })();
        });it("max", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "max", [function (m) {
                    return (() => {
                        return -m;
                    })();
                }]), -1);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "max", []), 5);
            })();
        });it("min", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "min", [function (m) {
                    return (() => {
                        return -m;
                    })();
                }]), -5);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "min", []), 1);
            })();
        });it("sum", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "sum", []), 15);
            })();
        });it("average", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "average", []), 3);
            })();
        });it("median", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 10], "median", []), 3);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5, 10], "median", []), 3.5);
            })();
        });it("product", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "product", []), 120);
            })();
        });it("group", function () {
            return (() => {
                return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5, 6], "group", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2);
                    })();
                }]), [[0, [2, 4, 6]], [1, [1, 3, 5]]]);
            })();
        });it("sort", function () {
            return (() => {
                _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [2, 4, 3, 5, 1], "sort", []), [1, 2, 3, 4, 5]);return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [2, 4, 3, 5, 1], "sort", [function (m) {
                    return (() => {
                        return -m;
                    })();
                }]), [5, 4, 3, 2, 1]);
            })();
        });it("sortDescending", function () {
            return (() => {
                _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [2, 4, 3, 5, 1], "sortDescending", []), [5, 4, 3, 2, 1]);return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [2, 4, 3, 5, 1], "sortDescending", [function (m) {
                    return (() => {
                        return -m;
                    })();
                }]), [1, 2, 3, 4, 5]);
            })();
        });it("reverse", function () {
            return (() => {
                return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "reverse", []), [5, 4, 3, 2, 1]);
            })();
        });it("except", function () {
            return (() => {
                return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "except", [[3]]), [1, 2, 4, 5]);
            })();
        });it("distinct", function () {
            return (() => {
                return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 2, 3, 3], "distinct", []), [1, 2, 3]);
            })();
        });it("union", function () {
            return (() => {
                return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3], "union", [[4, 5]]), [1, 2, 3, 4, 5]);
            })();
        });it("intersect", function () {
            return (() => {
                _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3], "intersect", [[2, 3, 4, 5]]), [2, 3]);return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3], "intersect", [[4, 5]]), []);
            })();
        });it("flatten", function () {
            return (() => {
                _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, [[2, 3], 4], 5], "flatten", []), [1, 2, 3, 4, 5]);return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, [[2, 3], 4], 5], "flatten", [1]), [1, [2, 3], 4, 5]);
            })();
        });it("forEach: without break", function () {
            return (() => {
                var r, ret;r = 0;ret = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "forEach", [function (element) {
                    return (() => {
                        r = r + element;
                    })();
                }]);_assert2.default.strictEqual(r, 15);return _assert2.default.strictEqual(ret, undefined);
            })();
        });it("forEach: with break", function () {
            return (() => {
                var r, ret;r = [];ret = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3, 4, 5], "forEach", [function (element, index) {
                    return (() => {
                        return index === 2 ? (() => {
                            return _manifest.break;
                        })() : (() => {
                            return r.push(element);
                        })();
                    })();
                }]);_assert2.default.deepStrictEqual(r, [1, 2]);return _assert2.default.strictEqual(ret, undefined);
            })();
        });it("asyncForEach: without break", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var r, oldTime, ret, actualMs, var_573300145710716007_6;r = 0;oldTime = new Date();ret = yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3], "asyncForEach", [function (element) {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);r = r + element;
                    });
                }]);actualMs = new Date() - oldTime;_assert2.default.strictEqual(r, 6);_assert2.default.strictEqual(ret, undefined);return (0, _assert2.default)(150 <= (var_573300145710716007_6 = actualMs) && var_573300145710716007_6 <= 190);
            });
        });it("asyncForEach: with break", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var r, oldTime, ret, actualMs, var_573300145710716007_7;r = 0;oldTime = new Date();ret = yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3], "asyncForEach", [function (element, index) {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);r = r + element;return index === 1 ? yield asyncToGenerator_573300145710716007.call(this, function* () {
                            return _manifest.break;
                        }) : undefined;
                    });
                }]);actualMs = new Date() - oldTime;_assert2.default.strictEqual(r, 3);_assert2.default.strictEqual(ret, undefined);return (0, _assert2.default)(100 <= (var_573300145710716007_7 = actualMs) && var_573300145710716007_7 <= 130);
            });
        });it("asyncSome: match", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var oldTime, r, actualMs, var_573300145710716007_8;oldTime = new Date();r = yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3], "asyncSome", [function (element) {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);return element > 0;
                    });
                }]);actualMs = new Date() - oldTime;_assert2.default.strictEqual(r, true);return (0, _assert2.default)(50 <= (var_573300145710716007_8 = actualMs) && var_573300145710716007_8 <= 70);
            });
        });it("asyncSome: not match", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var oldTime, r, actualMs, var_573300145710716007_9;oldTime = new Date();r = yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3], "asyncSome", [function (element) {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);return element > 3;
                    });
                }]);actualMs = new Date() - oldTime;_assert2.default.strictEqual(r, false);return (0, _assert2.default)(150 <= (var_573300145710716007_9 = actualMs) && var_573300145710716007_9 <= 190);
            });
        });it("asyncSome: empty 1", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var oldTime, r, actualMs, var_573300145710716007_10;oldTime = new Date();r = yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [], "asyncSome", [function (element) {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);return true;
                    });
                }]);actualMs = new Date() - oldTime;_assert2.default.strictEqual(r, false);return (0, _assert2.default)(0 <= (var_573300145710716007_10 = actualMs) && var_573300145710716007_10 <= 10);
            });
        });it("asyncSome: empty 2", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var oldTime, r, actualMs, var_573300145710716007_11;oldTime = new Date();r = yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [], "asyncSome", [function (element) {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);return false;
                    });
                }]);actualMs = new Date() - oldTime;_assert2.default.strictEqual(r, false);return (0, _assert2.default)(0 <= (var_573300145710716007_11 = actualMs) && var_573300145710716007_11 <= 10);
            });
        });it("asyncEvery: match", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var oldTime, r, actualMs, var_573300145710716007_12;oldTime = new Date();r = yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3], "asyncEvery", [function (element) {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);return element > 0;
                    });
                }]);actualMs = new Date() - oldTime;_assert2.default.strictEqual(r, true);return (0, _assert2.default)(150 <= (var_573300145710716007_12 = actualMs) && var_573300145710716007_12 <= 190);
            });
        });it("asyncEvery: not match", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var oldTime, r, actualMs, var_573300145710716007_13;oldTime = new Date();r = yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3], "asyncEvery", [function (element) {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);return element > 3;
                    });
                }]);actualMs = new Date() - oldTime;_assert2.default.strictEqual(r, false);return (0, _assert2.default)(50 <= (var_573300145710716007_13 = actualMs) && var_573300145710716007_13 <= 70);
            });
        });it("asyncEvery: empty 1", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var oldTime, r, actualMs, var_573300145710716007_14;oldTime = new Date();r = yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [], "asyncEvery", [function (element) {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);return true;
                    });
                }]);actualMs = new Date() - oldTime;_assert2.default.strictEqual(r, true);return (0, _assert2.default)(0 <= (var_573300145710716007_14 = actualMs) && var_573300145710716007_14 <= 10);
            });
        });it("asyncEvery: empty 2", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var oldTime, r, actualMs, var_573300145710716007_15;oldTime = new Date();r = yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [], "asyncEvery", [function (element) {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);return false;
                    });
                }]);actualMs = new Date() - oldTime;_assert2.default.strictEqual(r, true);return (0, _assert2.default)(0 <= (var_573300145710716007_15 = actualMs) && var_573300145710716007_15 <= 10);
            });
        });it("asyncMap", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var oldTime, r, actualMs, var_573300145710716007_16;oldTime = new Date();r = yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [1, 2, 3], "asyncMap", [function (element) {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);return element * 2;
                    });
                }]);actualMs = new Date() - oldTime;_assert2.default.deepStrictEqual(r, [2, 4, 6]);return (0, _assert2.default)(150 <= (var_573300145710716007_16 = actualMs) && var_573300145710716007_16 <= 190);
            });
        });it("asyncMap: empty", function () {
            return asyncToGenerator_573300145710716007.call(this, function* () {
                var oldTime, r, actualMs, var_573300145710716007_17;oldTime = new Date();r = yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [], "asyncMap", [function (element) {
                    return asyncToGenerator_573300145710716007.call(this, function* () {
                        yield dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [50]);return element * 2;
                    });
                }]);actualMs = new Date() - oldTime;_assert2.default.deepStrictEqual(r, []);return (0, _assert2.default)(0 <= (var_573300145710716007_17 = actualMs) && var_573300145710716007_17 <= 10);
            });
        });it("toObject", function () {
            return (() => {
                return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [["a", 1], ["b", 2]], "toObject", []), { a: 1, b: 2 });
            })();
        });it("join", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [["a", "b"], ["c", "d"]], "join", [":", ","]), "a:b,c:d");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, [["a", "b"], ["c", "d"]], "join", [[":", ","]]), "a:b,c:d");
            })();
        });it("randomOne", function () {
            return (() => {
                var arr, r;arr = [1, 2, 3, 4, 5, 6, 7, 8, 9];r = (0, _manifest.repeat)(20, function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        return dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "randomOne", []);
                    })();
                });(0, _assert2.default)(r.every(function (m) {
                    return (() => {
                        return typeof m === "number";
                    })();
                }));return (0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r, "distinct", []).length > 1);
            })();
        });it("random without argument", function () {
            return (() => {
                var arr, r1, r2;arr = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20];r1 = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "random", []);r2 = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "random", []);_assert2.default.strictEqual(r1.length, arr.length);_assert2.default.strictEqual(r2.length, arr.length);(0, _assert2.default)(r1.every(function (m) {
                    return (() => {
                        return typeof m === "number";
                    })();
                }));(0, _assert2.default)(r2.every(function (m) {
                    return (() => {
                        return typeof m === "number";
                    })();
                }));return _assert2.default.notDeepStrictEqual(r1, r2);
            })();
        });it("random with argument", function () {
            return (() => {
                var arr, r1, r2;arr = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22];r1 = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "random", [20]);r2 = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "random", [20]);_assert2.default.strictEqual(r1.length, 20);_assert2.default.strictEqual(r2.length, 20);(0, _assert2.default)(r1.every(function (m) {
                    return (() => {
                        return typeof m === "number";
                    })();
                }));(0, _assert2.default)(r2.every(function (m) {
                    return (() => {
                        return typeof m === "number";
                    })();
                }));return _assert2.default.notDeepStrictEqual(r1, r2);
            })();
        });it("takeRandomOne", function () {
            return (() => {
                var arr, r;arr = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22];r = (0, _manifest.repeat)(20, function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        return dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "takeRandomOne", []);
                    })();
                });(0, _assert2.default)(r.every(function (m) {
                    return (() => {
                        return typeof m === "number";
                    })();
                }));(0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r, "distinct", []).length > 1);return _assert2.default.strictEqual(arr.length, 2);
            })();
        });it("takeRandom without argument", function () {
            return (() => {
                var arr1, arr2, r1, r2;arr1 = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20];arr2 = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20];r1 = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr1, "takeRandom", []);r2 = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr2, "takeRandom", []);_assert2.default.strictEqual(r1.length, 20);_assert2.default.strictEqual(r2.length, 20);(0, _assert2.default)(r1.every(function (m) {
                    return (() => {
                        return typeof m === "number";
                    })();
                }));(0, _assert2.default)(r2.every(function (m) {
                    return (() => {
                        return typeof m === "number";
                    })();
                }));_assert2.default.notDeepStrictEqual(r1, r2);_assert2.default.strictEqual(arr1.length, 0);return _assert2.default.strictEqual(arr2.length, 0);
            })();
        });it("takeRandom with argument", function () {
            return (() => {
                var arr1, arr2, r1, r2;arr1 = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22];arr2 = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22];r1 = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr1, "takeRandom", [20]);r2 = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr2, "takeRandom", [20]);_assert2.default.strictEqual(r1.length, 20);_assert2.default.strictEqual(r2.length, 20);(0, _assert2.default)(r1.every(function (m) {
                    return (() => {
                        return typeof m === "number";
                    })();
                }));(0, _assert2.default)(r2.every(function (m) {
                    return (() => {
                        return typeof m === "number";
                    })();
                }));_assert2.default.notDeepStrictEqual(r1, r2);_assert2.default.strictEqual(arr1.length, 2);return _assert2.default.strictEqual(arr2.length, 2);
            })();
        });it("removeAt", function () {
            return (() => {
                var arr, r;arr = [1, 2, 3, 4, 5];r = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "removeAt", [1]);_assert2.default.strictEqual(r, arr);return _assert2.default.deepStrictEqual(arr, [1, 3, 4, 5]);
            })();
        });it("remove", function () {
            return (() => {
                var arr, r;arr = [1, 2, 2, 3, 4];r = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "remove", [2]);_assert2.default.strictEqual(r, arr);_assert2.default.deepStrictEqual(arr, [1, 2, 3, 4]);return _assert2.default.throws(function () {
                    return (() => {
                        return dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "remove", [5]);
                    })();
                });
            })();
        });it("removeAll", function () {
            return (() => {
                var arr, r;arr = [1, 2, 2, 3, 4];r = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "removeAll", [2]);_assert2.default.strictEqual(r, arr);_assert2.default.deepStrictEqual(arr, [1, 3, 4]);r = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "removeAll", [2]);_assert2.default.strictEqual(r, arr);return _assert2.default.deepStrictEqual(arr, [1, 3, 4]);
            })();
        });it("removeMatch", function () {
            return (() => {
                var arr, r;arr = [1, 2, 3, 4, 5];r = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "removeMatch", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 0;
                    })();
                }]);_assert2.default.strictEqual(r, arr);_assert2.default.deepStrictEqual(arr, [1, 3, 4, 5]);return _assert2.default.throws(function () {
                    return (() => {
                        return dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "removeMatch", [function (m) {
                            return (() => {
                                return m === 10;
                            })();
                        }]);
                    })();
                });
            })();
        });it("removeAllMatch", function () {
            return (() => {
                var arr, r;arr = [1, 2, 3, 4, 5];r = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "removeAllMatch", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 0;
                    })();
                }]);_assert2.default.strictEqual(r, arr);_assert2.default.deepStrictEqual(arr, [1, 3, 5]);r = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "removeAllMatch", [function (m) {
                    return (() => {
                        return mod_573300145710716007(m, 2) === 0;
                    })();
                }]);_assert2.default.strictEqual(r, arr);return _assert2.default.deepStrictEqual(arr, [1, 3, 5]);
            })();
        });it("insertBefore", function () {
            return (() => {
                var arr, r;arr = [1, 2, 3, 4, 5];r = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "insertBefore", [2, 10, 20]);_assert2.default.strictEqual(r, arr);_assert2.default.deepStrictEqual(arr, [1, 10, 20, 2, 3, 4, 5]);return _assert2.default.throws(function () {
                    return (() => {
                        return dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "insertBefore", [6, 10, 20]);
                    })();
                });
            })();
        });it("insertBeforeIndex", function () {
            return (() => {
                var arr, r;arr = [1, 2, 3, 4, 5];r = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "insertBeforeIndex", [2, 10, 20]);_assert2.default.strictEqual(r, arr);_assert2.default.deepStrictEqual(arr, [1, 2, 10, 20, 3, 4, 5]);r = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "insertBeforeIndex", [7, 10, 20]);_assert2.default.strictEqual(r, arr);return _assert2.default.deepStrictEqual(arr, [1, 2, 10, 20, 3, 4, 5, 10, 20]);
            })();
        });return it("insertAfter", function () {
            return (() => {
                var arr, r;arr = [10, 20];r = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "insertAfter", [10, 100]);_assert2.default.strictEqual(r, arr);_assert2.default.deepStrictEqual(arr, [10, 100, 20]);return _assert2.default.throws(function () {
                    return (() => {
                        return dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, arr, "insertAfter", [1, 100]);
                    })();
                });
            })();
        });
    })();
});describe("date", function () {
    return (() => {
        it("add", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, new Date(50000), "add", [20000]).getTime(), 70000);
            })();
        });it("subtract", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, new Date(50000), "subtract", [20000]).getTime(), 30000);
            })();
        });return it("equals", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, new Date(50000), "equals", [new Date(50000)]), true);
            })();
        });
    })();
});describe("json", function () {
    return (() => {
        return it("clone", function () {
            return (() => {
                var a, b;a = { foo: 1 };b = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, JSON, "clone", [a]);_assert2.default.notStrictEqual(b, a);return _assert2.default.deepStrictEqual(b, a);
            })();
        });
    })();
});describe("number static", function () {
    return (() => {
        it("isFraction", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Number, "isFraction", [1.5]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Number, "isFraction", [1]), false);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Number, "isFraction", [null]), false);
            })();
        });return it("parseFloat", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Number, "parseFloat", ["1.5"]), 1.5);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Number, "parseFloat", ["1.5%"]), 0.015);
            })();
        });
    })();
});describe("number", function () {
    return (() => {
        it("approxEquals", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1, "approxEquals", [1.000000001]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1, "approxEquals", [0.999999999]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1, "approxEquals", [1.001]), false);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1, "approxEquals", [0.999]), false);
            })();
        });it("approxGreaterThan", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1, "approxGreaterThan", [1.000000001]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1, "approxGreaterThan", [0.999999999]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1, "approxGreaterThan", [1.001]), false);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1, "approxGreaterThan", [0.999]), true);
            })();
        });it("approxLessThan", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1, "approxLessThan", [1.000000001]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1, "approxLessThan", [0.999999999]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1, "approxLessThan", [1.001]), true);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1, "approxLessThan", [0.999]), false);
            })();
        });it("pad", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 123.4, "pad", [5, 2]), "00123.40");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 123.4, "pad", [5]), "00123");
            })();
        });return it("format", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 123.4, "format", [{ integerSize: 5, fractionalSize: 2 }]), "00123.40");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 123.4, "format", [{ integerSize: 5 }]), "00123");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 123.4, "format", []), "123");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 123.6, "format", []), "124");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, -123.4, "format", []), "-123");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 123.4, "format", [{ forcesSign: true }]), "+123");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, -123.4, "format", [{ forcesSign: true }]), "-123");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 123.4, "format", [{ radix: 16 }]), "7b");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1234567.890123, "format", [{ integerGroupEnabled: true }]), "1,234,568");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1234567.890123, "format", [{ integerGroupEnabled: true, integerGroupSeparator: "|", integerGroupSize: 4 }]), "123|4568");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1234567.890123, "format", [{ fractionalSize: 9, integerGroupEnabled: true, fractionalGroupEnabled: true }]), "1,234,567.890 123 000");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, 1234567.890123, "format", [{ integerSize: 12, fractionalSize: 9, forcesSign: true, integerGroupEnabled: true, integerGroupSeparator: "|", integerGroupSize: 4, fractionalGroupEnabled: true, fractionalGroupSeparator: ",", fractionalGroupSize: 2 }]), "+0000|0123|4567.89,01,23,00,0");
            })();
        });
    })();
});describe("object", function () {
    return (() => {
        it("isObject", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "isObject", [{}]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "isObject", [[]]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "isObject", [function () {
                    var arg_573300145710716007 = arguments;return (() => {})();
                }]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "isObject", [null]), false);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "isObject", [undefined]), false);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "isObject", [3]), false);
            })();
        });it("isNormalObject", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "isNormalObject", [{}]), true);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "isNormalObject", [[]]), false);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "isNormalObject", [function () {
                    var arg_573300145710716007 = arguments;return (() => {})();
                }]), false);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "isNormalObject", [null]), false);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "isNormalObject", [undefined]), false);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "isNormalObject", [3]), false);
            })();
        });it("clone", function () {
            return (() => {
                var a, b;a = { foo: { bar: 1 }, other: 2 };b = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "clone", [a]);_assert2.default.deepStrictEqual(b, a);_assert2.default.notStrictEqual(b, a);return _assert2.default.strictEqual(b.foo, a.foo);
            })();
        });it("keyValues", function () {
            return (() => {
                return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "keyValues", [{ one: 1, other: 2 }]), [["one", 1], ["other", 2]]);
            })();
        });it("deepAssign", function () {
            return (() => {
                var slaveSettings, masterSettings;slaveSettings = { a: 1, b: { c: 5, d: 4 }, e: 8 };masterSettings = { a: 2, b: { c: 6, g: 3 }, f: 0 };dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "deepAssign", [slaveSettings, masterSettings]);return _assert2.default.deepStrictEqual(slaveSettings, { a: 2, b: { c: 6, d: 4, g: 3 }, e: 8, f: 0 });
            })();
        });it("absorb", function () {
            return (() => {
                var settings, defaultSettings;settings = { port: 8080 };defaultSettings = { host: "127.0.0.1", port: 80 };dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "absorb", [settings, defaultSettings]);return _assert2.default.deepStrictEqual(settings, { host: "127.0.0.1", port: 8080 });
            })();
        });it("deepAbsorb", function () {
            return (() => {
                var subjectSettings, objectSettings;subjectSettings = { a: 1, b: { c: 5, d: 4 }, e: 8 };objectSettings = { a: 2, b: { c: 6, g: 3 }, f: 0 };dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "deepAbsorb", [subjectSettings, objectSettings]);return _assert2.default.deepStrictEqual(subjectSettings, { a: 1, b: { c: 5, d: 4, g: 3 }, e: 8, f: 0 });
            })();
        });return it("deepClone", function () {
            return (() => {
                var a, b, c, d;a = { a: 1, b: { c: 5, d: 4 }, e: 8 };b = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "deepClone", [a]);_assert2.default.deepStrictEqual(b, a);_assert2.default.notStrictEqual(b, a);_assert2.default.deepStrictEqual(b.b, a.b);_assert2.default.notStrictEqual(b.b, a.b);c = { a: function () {
                        var arg_573300145710716007 = arguments;return (() => {})();
                    }, b: 7 };c.a.m1 = 5;d = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Object, "deepClone", [c]);return _assert2.default.deepStrictEqual(d, { a: { m1: 5 }, b: 7 });
            })();
        });
    })();
});describe("timer", function () {
    return (() => {
        it("IntervalTimer: normal", function (done) {
            return (() => {
                var initTime, timer, count, var_573300145710716007_18;_assert2.default.strictEqual(_manifest.IntervalTimer.getPrecision(), 30);initTime = new Date();timer = new _manifest.IntervalTimer({ interval: 100 });(0, _assert2.default)(0 <= (var_573300145710716007_18 = timer.startTime - initTime) && var_573300145710716007_18 < 20);count = 0;return timer.onArrive(function (e) {
                    return (() => {
                        var now, var_573300145710716007_19, var_573300145710716007_20;now = new Date();(0, _assert2.default)(e.idealTime instanceof Date);(0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, e.idealTime, "equals", [dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, timer.startTime, "add", [count * 100])]));(0, _assert2.default)(e.nowTime instanceof Date);(0, _assert2.default)(0 <= (var_573300145710716007_19 = now - e.nowTime) && var_573300145710716007_19 < 20);(0, _assert2.default)(0 <= (var_573300145710716007_20 = e.nowTime - e.idealTime) && var_573300145710716007_20 < 50);_assert2.default.strictEqual(e.index, count);_assert2.default.strictEqual(timer.getCounter(), e.index + 1);_assert2.default.strictEqual(timer.getRunning(), true);count = count + 1;return count === 5 ? (() => {
                            timer.stop();_assert2.default.strictEqual(timer.getRunning(), false);return done();
                        })() : undefined;
                    })();
                });
            })();
        });it("IntervalTimer: skipsPast, startTime < now", function (done) {
            return (() => {
                var initTime, timer, count;initTime = new Date();timer = new _manifest.IntervalTimer({ interval: 100, startTime: dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, initTime, "subtract", [200]), endTime: dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, initTime, "add", [300]), skipsPast: true });count = 0;return timer.onArrive(function (e) {
                    return (() => {
                        var now, var_573300145710716007_21, var_573300145710716007_22, var_573300145710716007_23;now = new Date();(0, _assert2.default)(e.idealTime instanceof Date);count === 0 ? (() => {
                            return (0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, e.idealTime, "equals", [dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, initTime, "subtract", [200])]));
                        })() : (() => {
                            return count === 1 ? (() => {
                                return (0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, e.idealTime, "equals", [dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, initTime, "add", [100])]));
                            })() : (() => {
                                return count === 2 ? (() => {
                                    return (0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, e.idealTime, "equals", [dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, initTime, "add", [200])]));
                                })() : undefined;
                            })();
                        })();(0, _assert2.default)(e.nowTime instanceof Date);(0, _assert2.default)(0 <= (var_573300145710716007_21 = now - e.nowTime) && var_573300145710716007_21 < 20);count === 0 ? (() => {
                            return (0, _assert2.default)(200 <= (var_573300145710716007_22 = e.nowTime - e.idealTime) && var_573300145710716007_22 < 250);
                        })() : (() => {
                            return (0, _assert2.default)(0 <= (var_573300145710716007_23 = e.nowTime - e.idealTime) && var_573300145710716007_23 < 50);
                        })();_assert2.default.strictEqual(e.index, count);_assert2.default.strictEqual(timer.getCounter(), e.index + 1);count < 2 ? (() => {
                            return _assert2.default.strictEqual(timer.getRunning(), true);
                        })() : (() => {
                            return _assert2.default.strictEqual(timer.getRunning(), false);
                        })();count = count + 1;return count === 3 ? (() => {
                            return done();
                        })() : undefined;
                    })();
                });
            })();
        });it("IntervalTimer: skipsPast, startTime < now, not includesStart, includesEnd", function (done) {
            return (() => {
                var initTime, timer, count;initTime = new Date();timer = new _manifest.IntervalTimer({ interval: 100, startTime: dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, initTime, "subtract", [200]), endTime: dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, initTime, "add", [300]), includesStart: false, includesEnd: true, skipsPast: true });count = 0;return timer.onArrive(function (e) {
                    return (() => {
                        var now, var_573300145710716007_24, var_573300145710716007_25;now = new Date();(0, _assert2.default)(e.idealTime instanceof Date);count === 0 ? (() => {
                            return (0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, e.idealTime, "equals", [dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, initTime, "add", [100])]));
                        })() : (() => {
                            return count === 1 ? (() => {
                                return (0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, e.idealTime, "equals", [dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, initTime, "add", [200])]));
                            })() : (() => {
                                return count === 2 ? (() => {
                                    return (0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, e.idealTime, "equals", [dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, initTime, "add", [300])]));
                                })() : undefined;
                            })();
                        })();(0, _assert2.default)(e.nowTime instanceof Date);(0, _assert2.default)(0 <= (var_573300145710716007_24 = now - e.nowTime) && var_573300145710716007_24 < 20);(0, _assert2.default)(0 <= (var_573300145710716007_25 = e.nowTime - e.idealTime) && var_573300145710716007_25 < 50);_assert2.default.strictEqual(e.index, count);_assert2.default.strictEqual(timer.getCounter(), e.index + 1);count < 2 ? (() => {
                            return _assert2.default.strictEqual(timer.getRunning(), true);
                        })() : (() => {
                            return _assert2.default.strictEqual(timer.getRunning(), false);
                        })();count = count + 1;return count === 3 ? (() => {
                            return done();
                        })() : undefined;
                    })();
                });
            })();
        });it("IntervalTimer: heavy work", function (done) {
            return (() => {
                var initTime, timer, count, var_573300145710716007_26;initTime = new Date();timer = new _manifest.IntervalTimer({ interval: 100 });(0, _assert2.default)(0 <= (var_573300145710716007_26 = timer.startTime - initTime) && var_573300145710716007_26 < 20);count = 0;timer.onArrive(function (e) {
                    return (() => {
                        var now, var_573300145710716007_27, var_573300145710716007_28, var_573300145710716007_29, var_573300145710716007_30, var_573300145710716007_31, var_573300145710716007_32;now = new Date();(0, _assert2.default)(e.idealTime instanceof Date);(0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, e.idealTime, "equals", [dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, timer.startTime, "add", [count * 100])]));(0, _assert2.default)(e.nowTime instanceof Date);(0, _assert2.default)(0 <= (var_573300145710716007_27 = now - e.nowTime) && var_573300145710716007_27 < 20);count === 0 ? (() => {
                            return (0, _assert2.default)(280 <= (var_573300145710716007_28 = e.nowTime - e.idealTime) && var_573300145710716007_28 < 350);
                        })() : (() => {
                            return count === 1 ? (() => {
                                return (0, _assert2.default)(210 <= (var_573300145710716007_29 = e.nowTime - e.idealTime) && var_573300145710716007_29 < 280);
                            })() : (() => {
                                return count === 2 ? (() => {
                                    return (0, _assert2.default)(140 <= (var_573300145710716007_30 = e.nowTime - e.idealTime) && var_573300145710716007_30 < 210);
                                })() : (() => {
                                    return count === 3 ? (() => {
                                        return (0, _assert2.default)(70 <= (var_573300145710716007_31 = e.nowTime - e.idealTime) && var_573300145710716007_31 < 140);
                                    })() : (() => {
                                        return (0, _assert2.default)(0 <= (var_573300145710716007_32 = e.nowTime - e.idealTime) && var_573300145710716007_32 < 70);
                                    })();
                                })();
                            })();
                        })();_assert2.default.strictEqual(e.index, count);_assert2.default.strictEqual(timer.getCounter(), e.index + 1);_assert2.default.strictEqual(timer.getRunning(), true);count = count + 1;return count === 5 ? (() => {
                            timer.stop();_assert2.default.strictEqual(timer.getRunning(), false);return done();
                        })() : undefined;
                    })();
                });return sleep(300);
            })();
        });it("IntervalTimer: heavy work, skipsPast", function (done) {
            return (() => {
                var initTime, timer, count, var_573300145710716007_33;initTime = new Date();timer = new _manifest.IntervalTimer({ interval: 100, skipsPast: true });(0, _assert2.default)(0 <= (var_573300145710716007_33 = timer.startTime - initTime) && var_573300145710716007_33 < 20);count = 0;timer.onArrive(function (e) {
                    return (() => {
                        var now, var_573300145710716007_34, var_573300145710716007_35, var_573300145710716007_36;now = new Date();(0, _assert2.default)(e.idealTime instanceof Date);count === 0 ? (() => {
                            return (0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, e.idealTime, "equals", [timer.startTime]));
                        })() : (() => {
                            return count === 1 ? (() => {
                                return (0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, e.idealTime, "equals", [dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, timer.startTime, "add", [300])]));
                            })() : (() => {
                                return count === 2 ? (() => {
                                    return (0, _assert2.default)(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, e.idealTime, "equals", [dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, timer.startTime, "add", [400])]));
                                })() : undefined;
                            })();
                        })();(0, _assert2.default)(e.nowTime instanceof Date);(0, _assert2.default)(0 <= (var_573300145710716007_34 = now - e.nowTime) && var_573300145710716007_34 < 20);count === 0 ? (() => {
                            return (0, _assert2.default)(230 <= (var_573300145710716007_35 = e.nowTime - e.idealTime) && var_573300145710716007_35 < 300);
                        })() : (() => {
                            return (0, _assert2.default)(0 <= (var_573300145710716007_36 = e.nowTime - e.idealTime) && var_573300145710716007_36 < 50);
                        })();_assert2.default.strictEqual(e.index, count);_assert2.default.strictEqual(timer.getCounter(), e.index + 1);_assert2.default.strictEqual(timer.getRunning(), true);count = count + 1;return count === 3 ? (() => {
                            timer.stop();_assert2.default.strictEqual(timer.getRunning(), false);return done();
                        })() : undefined;
                    })();
                });return sleep(250);
            })();
        });it("Observer: change", function (done) {
            return (() => {
                var value;value = 1;new _manifest.Observer(function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        return value;
                    })();
                }).onChange(function (e) {
                    return (() => {
                        _assert2.default.strictEqual(e.oldValue, 1);_assert2.default.strictEqual(e.newValue, 2);return done();
                    })();
                });return setTimeout(function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        value = 2;
                    })();
                }, 200);
            })();
        });it("Observer: update", function (done) {
            return (() => {
                var count, value;count = 0;value = 1;new _manifest.Observer(function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        return value;
                    })();
                }).onUpdate(function (e) {
                    return (() => {
                        return count === 0 ? (() => {
                            _assert2.default.strictEqual(e.value, 2);count = count + 1;
                        })() : (() => {
                            _assert2.default.strictEqual(e.value, 3);return done();
                        })();
                    })();
                });value = 2;return setTimeout(function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        value = 3;
                    })();
                }, 200);
            })();
        });return it("Observer: manual update", function () {
            return (() => {
                var updateCount, changeCount, value, observer;updateCount = 0;changeCount = 0;value = 10;observer = new _manifest.Observer(function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        return value;
                    })();
                }).onUpdate(function (e) {
                    return (() => {
                        updateCount = updateCount + 1;
                    })();
                }).onChange(function (e) {
                    return (() => {
                        changeCount = changeCount + 1;
                    })();
                });_assert2.default.strictEqual(updateCount, 0);_assert2.default.strictEqual(changeCount, 0);value = 20;observer.check();_assert2.default.strictEqual(updateCount, 1);_assert2.default.strictEqual(changeCount, 0);value = 30;observer.check();_assert2.default.strictEqual(updateCount, 2);_assert2.default.strictEqual(changeCount, 1);observer.check();_assert2.default.strictEqual(updateCount, 2);_assert2.default.strictEqual(changeCount, 1);observer.check(true);_assert2.default.strictEqual(updateCount, 3);return _assert2.default.strictEqual(changeCount, 2);
            })();
        });
    })();
});describe("cmath", function () {
    return (() => {
        it("equals", function () {
            return (() => {
                _assert2.default.strictEqual(_manifest.cmath.equals(_manifest.Point.from("1+2i"), _manifest.Point.from("1+2i")), true);return _assert2.default.strictEqual(_manifest.cmath.equals(_manifest.Point.from("1+2i"), _manifest.Point.from("1+3i")), false);
            })();
        });it("approxEquals", function () {
            return (() => {
                _assert2.default.strictEqual(_manifest.cmath.approxEquals(_manifest.Point.from("1+2i"), _manifest.Point.from("1+2.000000001i")), true);return _assert2.default.strictEqual(_manifest.cmath.approxEquals(_manifest.Point.from("1+2i"), _manifest.Point.from("1+2.001i")), false);
            })();
        });it("opposite", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.cmath.opposite(_manifest.Point.from("1+2i")).toString(), "(-1,-2)");
            })();
        });it("reciprocal", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.cmath.reciprocal(_manifest.Point.from("1+2i")).toString(), "(0.2,-0.4)");
            })();
        });it("conjugate", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.cmath.conjugate(_manifest.Point.from("1+2i")).toString(), "(1,-2)");
            })();
        });it("abs", function () {
            return (() => {
                _assert2.default.strictEqual(_manifest.cmath.abs(_manifest.Point.from("1+2i")), 2.2360679774997896964);_assert2.default.strictEqual(_manifest.cmath.abs(_manifest.Point.from("-1")), 1);return _assert2.default.strictEqual(_manifest.cmath.abs(_manifest.Point.from("i")), 1);
            })();
        });it("phase", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, _manifest.cmath.phase(_manifest.Point.from("1+2i")), "pad", [1, 9]), "1.107148718");_assert2.default.strictEqual(_manifest.cmath.phase(_manifest.Point.from("1")), 0);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, _manifest.cmath.phase(_manifest.Point.from("i")), "pad", [1, 9]), "1.570796327");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, _manifest.cmath.phase(_manifest.Point.from("-1")), "pad", [1, 9]), "3.141592654");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, _manifest.cmath.phase(_manifest.Point.from("-i")), "pad", [1, 9]), "-1.570796327");return _assert2.default.strictEqual(_manifest.cmath.phase(_manifest.Point.from("0")), 0);
            })();
        });it("phaseInDegrees", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, _manifest.cmath.phaseInDegrees(_manifest.Point.from("1+2i")), "pad", [1, 9]), "63.434948823");_assert2.default.strictEqual(_manifest.cmath.phaseInDegrees(_manifest.Point.from("1")), 0);_assert2.default.strictEqual(_manifest.cmath.phaseInDegrees(_manifest.Point.from("i")), 90);_assert2.default.strictEqual(_manifest.cmath.phaseInDegrees(_manifest.Point.from("-1")), 180);_assert2.default.strictEqual(_manifest.cmath.phaseInDegrees(_manifest.Point.from("-i")), -90);return _assert2.default.strictEqual(_manifest.cmath.phaseInDegrees(_manifest.Point.from("0")), 0);
            })();
        });it("add", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.cmath.add(_manifest.Point.from("1+2i"), _manifest.Point.from("3+5i")).toString(), "(4,7)");
            })();
        });it("subtract", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.cmath.subtract(_manifest.Point.from("1+2i"), _manifest.Point.from("3+5i")).toString(), "(-2,-3)");
            })();
        });it("multiply", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.cmath.multiply(_manifest.Point.from("1+2i"), _manifest.Point.from("3+5i")).toString(), "(-7,11)");
            })();
        });it("divide", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.cmath.divide(_manifest.Point.from("1+2i"), _manifest.Point.from("3+4i")).toString(), "(0.44,0.08)");
            })();
        });it("distance", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, _manifest.cmath.distance(_manifest.Point.from("1+2i"), _manifest.Point.from("3+5i")), "pad", [1, 9]), "3.605551275");
            })();
        });it("exp", function () {
            return (() => {
                var r;r = _manifest.cmath.exp(_manifest.Point.from("1+2i"));_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.x, "pad", [1, 9]), "-1.131204384");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.y, "pad", [1, 9]), "2.471726672");
            })();
        });it("log", function () {
            return (() => {
                var r;r = _manifest.cmath.log(_manifest.Point.from("1+2i"));_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.x, "pad", [1, 9]), "0.804718956");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.y, "pad", [1, 9]), "1.107148718");
            })();
        });it("sqrt", function () {
            return (() => {
                var r;r = _manifest.cmath.sqrt(_manifest.Point.from("1+2i"));_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.x, "pad", [1, 9]), "1.272019650");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.y, "pad", [1, 9]), "0.786151378");
            })();
        });it("cos", function () {
            return (() => {
                var r;r = _manifest.cmath.cos(_manifest.Point.from("1+2i"));_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.x, "pad", [1, 9]), "2.032723007");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.y, "pad", [1, 9]), "-3.051897799");
            })();
        });it("sin", function () {
            return (() => {
                var r;r = _manifest.cmath.sin(_manifest.Point.from("1+2i"));_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.x, "pad", [1, 9]), "3.165778513");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.y, "pad", [1, 9]), "1.959601041");
            })();
        });it("tan", function () {
            return (() => {
                var r;r = _manifest.cmath.tan(_manifest.Point.from("1+2i"));_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.x, "pad", [1, 9]), "0.033812826");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.y, "pad", [1, 9]), "1.014793616");
            })();
        });it("acos", function () {
            return (() => {
                var r;r = _manifest.cmath.acos(_manifest.Point.from("1+2i"));_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.x, "pad", [1, 9]), "1.143717740");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.y, "pad", [1, 9]), "-1.528570919");
            })();
        });it("asin", function () {
            return (() => {
                var r;r = _manifest.cmath.asin(_manifest.Point.from("1+2i"));_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.x, "pad", [1, 9]), "0.427078586");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.y, "pad", [1, 9]), "1.528570919");
            })();
        });return it("atan", function () {
            return (() => {
                var r;r = _manifest.cmath.atan(_manifest.Point.from("1+2i"));_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.x, "pad", [1, 9]), "1.338972522");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, r.y, "pad", [1, 9]), "0.402359478");
            })();
        });
    })();
});describe("point", function () {
    return (() => {
        it("new", function () {
            return (() => {
                var p;p = new _manifest.Point(1, 2);_assert2.default.strictEqual(p.x, 1);return _assert2.default.strictEqual(p.y, 2);
            })();
        });it("from: 2 numbers", function () {
            return (() => {
                var p;p = _manifest.Point.from(1, 2);_assert2.default.strictEqual(p.x, 1);return _assert2.default.strictEqual(p.y, 2);
            })();
        });it("from: 1 number", function () {
            return (() => {
                var p;p = _manifest.Point.from(1);_assert2.default.strictEqual(p.x, 1);return _assert2.default.strictEqual(p.y, 0);
            })();
        });it("from: point", function () {
            return (() => {
                var p1, p2;p1 = new _manifest.Point(1, 2);p2 = _manifest.Point.from(p1);_assert2.default.notStrictEqual(p2, p1);_assert2.default.strictEqual(p2.x, 1);return _assert2.default.strictEqual(p2.y, 2);
            })();
        });it("from: string", function () {
            return (() => {
                var p;p = _manifest.Point.from("1+2i");_assert2.default.strictEqual(p.x, 1);return _assert2.default.strictEqual(p.y, 2);
            })();
        });it("from: array", function () {
            return (() => {
                var p;p = _manifest.Point.from([1, 2]);_assert2.default.strictEqual(p.x, 1);return _assert2.default.strictEqual(p.y, 2);
            })();
        });it("fromArray", function () {
            return (() => {
                var p;p = _manifest.Point.fromArray([1, 2]);_assert2.default.strictEqual(p.x, 1);return _assert2.default.strictEqual(p.y, 2);
            })();
        });it("fromString", function () {
            return (() => {
                var p;p = _manifest.Point.fromString("1+2i");_assert2.default.strictEqual(p.x, 1);return _assert2.default.strictEqual(p.y, 2);
            })();
        });it("fromPolar", function () {
            return (() => {
                var p;p = _manifest.Point.fromPolar(2, Math.PI / 6);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, p.x, "pad", [1, 9]), "1.732050808");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, p.y, "pad", [1, 9]), "1.000000000");
            })();
        });it("fromPolarInDegrees", function () {
            return (() => {
                var p;p = _manifest.Point.fromPolarInDegrees(2, 30);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, p.x, "pad", [1, 9]), "1.732050808");_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, p.y, "pad", [1, 9]), "1.000000000");_assert2.default.strictEqual(_manifest.Point.fromPolarInDegrees(2, 0).toString(), "(2,0)");_assert2.default.strictEqual(_manifest.Point.fromPolarInDegrees(2, 90).toString(), "(0,2)");_assert2.default.strictEqual(_manifest.Point.fromPolarInDegrees(2, 180).toString(), "(-2,0)");return _assert2.default.strictEqual(_manifest.Point.fromPolarInDegrees(2, -90).toString(), "(0,-2)");
            })();
        });it("real", function () {
            return (() => {
                return _assert2.default.strictEqual(new _manifest.Point(1, 2).real(), 1);
            })();
        });it("imaginary", function () {
            return (() => {
                return _assert2.default.strictEqual(new _manifest.Point(1, 2).imaginary(), 2);
            })();
        });it("toString", function () {
            return (() => {
                return _assert2.default.strictEqual(new _manifest.Point(-7, 5).toString(), "(-7,5)");
            })();
        });it("toComplexString", function () {
            return (() => {
                _assert2.default.strictEqual(new _manifest.Point(1, 2).toComplexString(), "1+2i");_assert2.default.strictEqual(new _manifest.Point(0, 0).toComplexString(), "0+0i");_assert2.default.strictEqual(new _manifest.Point(0, 1).toComplexString(), "0+1i");_assert2.default.strictEqual(new _manifest.Point(0, -1).toComplexString(), "0-1i");return _assert2.default.strictEqual(new _manifest.Point(-1, 0).toComplexString(), "-1+0i");
            })();
        });it("toArray", function () {
            return (() => {
                return _assert2.default.deepStrictEqual(new _manifest.Point(1, 2).toArray(), [1, 2]);
            })();
        });it("clone", function () {
            return (() => {
                var p1, p2;p1 = new _manifest.Point(1, 2);p2 = p1.clone();_assert2.default.notStrictEqual(p2, p1);_assert2.default.strictEqual(p2.x, 1);return _assert2.default.strictEqual(p2.y, 2);
            })();
        });it("equals", function () {
            return (() => {
                _assert2.default.strictEqual(_manifest.Point.from("1+2i").equals(_manifest.Point.from("1+2i")), true);return _assert2.default.strictEqual(_manifest.Point.from("1+2i").equals(_manifest.Point.from("1+3i")), false);
            })();
        });it("approxEquals", function () {
            return (() => {
                _assert2.default.strictEqual(_manifest.Point.from("1+2i").approxEquals(_manifest.Point.from("1+2.000000001i")), true);return _assert2.default.strictEqual(_manifest.Point.from("1+2i").approxEquals(_manifest.Point.from("1+2.001i")), false);
            })();
        });it("opposite", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.Point.from("1+2i").opposite().toString(), "(-1,-2)");
            })();
        });it("reciprocal", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.Point.from("1+2i").reciprocal().toString(), "(0.2,-0.4)");
            })();
        });it("conjugate", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.Point.from("1+2i").conjugate().toString(), "(1,-2)");
            })();
        });it("abs", function () {
            return (() => {
                _assert2.default.strictEqual(_manifest.Point.from("1+2i").abs(), 2.2360679774997896964);_assert2.default.strictEqual(_manifest.Point.from("-1").abs(), 1);return _assert2.default.strictEqual(_manifest.Point.from("i").abs(), 1);
            })();
        });it("add", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.Point.from("1+2i").add(_manifest.Point.from("3+5i")).toString(), "(4,7)");
            })();
        });it("subtract", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.Point.from("1+2i").subtract(_manifest.Point.from("3+5i")).toString(), "(-2,-3)");
            })();
        });it("multiply", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.Point.from("1+2i").multiply(_manifest.Point.from("3+5i")).toString(), "(-7,11)");
            })();
        });it("divide", function () {
            return (() => {
                return _assert2.default.strictEqual(_manifest.Point.from("1+2i").divide(_manifest.Point.from("3+4i")).toString(), "(0.44,0.08)");
            })();
        });it("distance", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, _manifest.Point.from("1+2i").distance(_manifest.Point.from("3+5i")), "pad", [1, 9]), "3.605551275");
            })();
        });it("dotProduct", function () {
            return (() => {
                return _assert2.default.strictEqual(new _manifest.Point(2, 3).dotProduct(new _manifest.Point(4, 5)), 23);
            })();
        });it("crossProduct", function () {
            return (() => {
                return _assert2.default.strictEqual(new _manifest.Point(2, 3).crossProduct(new _manifest.Point(4, 5)), -2);
            })();
        });it("isOppositeTo", function () {
            return (() => {
                _assert2.default.strictEqual(new _manifest.Point(1, 2).isOppositeTo(new _manifest.Point(-1, -2)), true);return _assert2.default.strictEqual(new _manifest.Point(1, 2).isOppositeTo(new _manifest.Point(1, -2)), false);
            })();
        });it("phase", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, _manifest.Point.from("1+2i").phase(), "pad", [1, 9]), "1.107148718");
            })();
        });it("phaseTo", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, _manifest.Point.from("1+2i").phaseTo(_manifest.Point.from("i")), "pad", [1, 9]), "0.463647609");
            })();
        });it("phaseInDegrees", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, _manifest.Point.from("1+2i").phaseInDegrees(), "pad", [1, 9]), "63.434948823");
            })();
        });it("phaseInDegreesTo", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, _manifest.Point.from("1+2i").phaseInDegreesTo(_manifest.Point.from("i")), "pad", [1, 9]), "26.565051177");
            })();
        });it("scale", function () {
            return (() => {
                _assert2.default.strictEqual(new _manifest.Point(1, 2).scale(2).toString(), "(2,4)");return _assert2.default.strictEqual(new _manifest.Point(1, 2).scale(2, 3).toString(), "(2,6)");
            })();
        });it("rotate", function () {
            return (() => {
                var p;p = new _manifest.Point(1, 2).rotate(Math.PI / 6);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, p.x, "pad", [1, 9]), "-0.133974596");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, p.y, "pad", [1, 9]), "2.232050808");
            })();
        });return it("rotateDegrees", function () {
            return (() => {
                var p;p = new _manifest.Point(1, 2).rotateDegrees(30);_assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, p.x, "pad", [1, 9]), "-0.133974596");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, p.y, "pad", [1, 9]), "2.232050808");
            })();
        });
    })();
});describe("Uint8Array static", function () {
    return (() => {
        it("fromBase64", function () {
            return (() => {
                var bytes;bytes = dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Uint8Array, "fromBase64", ["AAECAw=="]);(0, _assert2.default)(bytes instanceof Uint8Array);return _assert2.default.deepStrictEqual(Array.from(bytes), [0, 1, 2, 3]);
            })();
        });it("fromString", function () {
            return (() => {
                return _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Uint8Array, "fromString", ["A我们BC"]), new Uint8Array([0x41, 0xe6, 0x88, 0x91, 0xe4, 0xbb, 0xac, 0x42, 0x43]));
            })();
        });return it("fromHex", function () {
            return (() => {
                _assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Uint8Array, "fromHex", [""]), new Uint8Array([]));_assert2.default.deepStrictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Uint8Array, "fromHex", ["010a"]), new Uint8Array([0x01, 0x0a]));return _assert2.default.throws(function () {
                    return (() => {
                        return dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Uint8Array, "fromHex", ["0"]);
                    })();
                });
            })();
        });
    })();
});describe("Uint8Array", function () {
    return (() => {
        it("bound", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, new Uint8Array([]), "bound", []), -1);return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, new Uint8Array([1, 1, 1]), "bound", []), 2);
            })();
        });it("toBase64", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, new Uint8Array([0, 1, 2, 3]), "toBase64", []), "AAECAw==");
            })();
        });it("toString", function () {
            return (() => {
                return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, new Uint8Array([0x41, 0xe6, 0x88, 0x91, 0xe4, 0xbb, 0xac, 0x42, 0x43]), "toString", []), "A我们BC");
            })();
        });return it("toHex", function () {
            return (() => {
                _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, new Uint8Array([]), "toHex", []), "");return _assert2.default.strictEqual(dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, new Uint8Array([0x01, 0x0a]), "toHex", []), "010a");
            })();
        });
    })();
});describe("Promise static", function () {
    return (() => {
        return it("delay", function () {
            return (() => {
                var oldTime;oldTime = new Date();return dotDotCalc_573300145710716007(_manifest.dotDot_573300145710716007, Promise, "delay", [500]).then(function () {
                    var arg_573300145710716007 = arguments;return (() => {
                        var actualMs, var_573300145710716007_37;actualMs = new Date() - oldTime;return (0, _assert2.default)(500 <= (var_573300145710716007_37 = actualMs) && var_573300145710716007_37 <= 525);
                    })();
                });
            })();
        });
    })();
});